<?php
// --------------------------
// Web services configuration
// --------------------------

/**
  * urnreg_path: the absolute path of web content of URNreg
  */
$urnreg_path="/Applications/MAMP/htdocs/urn/urnreg/";

/**
  * siledap_api_path: the absolute path of siledap_api folder
  */
$siledap_path="/Applications/MAMP/htdocs/urn/siledap_api_lib/";

/**
  * URN_BASE: dn base for managing the entries (URNs) in the LDAP
  */
$URN_LDAP_BASE="dc=urn,dc=myserver,dc=org";

/**
  * URN_VALUE_BASE: root namespaces managed by URNreg
  */
$URN_VALUE_BASE = array(
	"urn:example","urn:example2"
);

// ---------------------
// Browser configuration
// ---------------------

/**
  * API_URI_BASE: URI base for the web services
  */
$API_URI_BASE="http://localhost:8888/urn/urnreg/";

/**
  * SILEDAP_WS_URI_BASE: URI base for siLeDAP web services
  */
$SILEDAP_WS_URI_BASE="http://localhost:8888/urn/urnreg/siledap_api/";

/**
  * EMAIL_SENDER: sender's email when a request is accepted
  */
$EMAIL_SENDER = "urnreg@localhost.localdomain";

/**
  * EMAIL_BCC: administrator's email when a request is accepted
  */
$EMAIL_BCC = "ford.fairlane@localhost.localdomain";

/**
  * EMAIL_SUBJECT: subject of email when a request is accepted
  */
$EMAIL_SUBJECT = "Request for the URN %%URN_VALUE%%";

/**
  * EMAIL_TEXT: text of email when a request is received
  */
$EMAIL_TEXT = "Hello,\nThe request has been sent successfully. Along the next working day it will be processed and you'll receive an email.\nRegards\n";

/**
  * EMAIL_REJECT_TEXT: text of email when a request is rejected
  */
$EMAIL_REJECT_TEXT = "Hello,\nThe request has been denied. This usually happens when the information associated to the URN is not right. If you need more information, you could reply this email asking for it.\nRegards\n";

/**
  * EMAIL_ACCEPT_TEXT: text of email when a request is accepted
  */
$EMAIL_ACCEPT_TEXT = "Hello,\nCongratulations! The request has been ACCEPTED.\nRegards\n";

?>
