function URNregManager() {

	URNregManager.prototype.trimAll = function(sString) { 
		while (sString.substring(0,1) == ' ') { 
			sString = sString.substring(1, sString.length); 
		} 
		while (sString.substring(sString.length-1, sString.length) == ' ') { 
			sString = sString.substring(0,sString.length-1); 
		} 
		return sString; 
	} 

	URNregManager.prototype.getClassName = function(urnvalue) {
		var className="urninfo";
		// You can add here some rules for setting the class name ;)
		
		return className;
	}
	
	URNregManager.prototype.getBlockURNdiv = function(urnelem,showicons) {
       	var urnname=urnelem.getAttribute("value");
       	var descs=urnelem.getElementsByTagName("description");
       	var urndesc='';
       	for (var i=0; i<descs.length; i++) {
       		urndesc=descs[i].getAttribute("value");
       	}
		var divhtml='';
		divhtml+='  <div>';
		if (showicons) {
			if (!urnelem.getAttribute("delegated")) {
				divhtml+='    <div class="urnvalue"><span tooltip="true" title="Request a new URN" class="iconNew" onclick="urnregManager.showAddForm(\''+urnname+'\');">&nbsp;</span><span tooltip="true" title="Go to its register page" class="iconRegURL" onclick="window.location.href=\''+urnregConfig.baseURL+'search/?urn='+encodeURIComponent(urnname)+'\';">&nbsp;</span><span tooltip="true" title="Refresh this entry and its children URNs" class="iconUp" onclick="urnregManager.setURN(\''+urnname+'\');">&nbsp;</span>'+urnname+'</div>';
			}
			else {
				divhtml+='    <div class="urnvalue"><span tooltip="true" title="Go to its register page" class="iconRegURL" onclick="window.location.href=\''+urnelem.getAttribute("delegated")+'search/?urn='+encodeURIComponent(urnname)+'\';">&nbsp;</span><span tooltip="true" title="Refresh this entry and its children URNs" class="iconUp" onclick="urnregManager.setDelegatedURN(\''+urnname+'\',\''+urnelem.getAttribute("delegated")+'\');">&nbsp;</span>'+urnname+'</div>';
			}
		}
		var urnreps=urnelem.getElementsByTagName("presentation");
		for (var i=0; i<urnreps.length; i++) {
			divhtml+='    <div class="attr">';
			if (i==0) {
				divhtml+='      <div class="attrname">Representation</div>';
			}
			else {
				divhtml+='      <div class="attrname">&nbsp;</div>';
			}
			if (!urnreps[i].getAttribute("lang")) {
				divhtml+='      <div class="attrvalue">'+urnreps[i].getAttribute("value")+'</div>';
			}
			else {
				if (urnreps[i].getAttribute("lang")=="en") {
					divhtml+='      <div class="attrvalue"><span class="iconFlag" style="background: url(./icons/flags/gb.png) no-repeat;">&nbsp;</span>'+urnreps[i].getAttribute("value")+'</div>';
				}
				else {
					divhtml+='      <div class="attrvalue"><span class="iconFlag" style="background: url(./icons/flags/'+urnreps[i].getAttribute("lang")+'.png) no-repeat;">&nbsp;</span>'+urnreps[i].getAttribute("value")+'</div>';
				}
			}
			divhtml+='    </div>';
		}
		divhtml+='    <div class="attr">';
		divhtml+='      <div class="attrname">Description</div>';
		divhtml+='      <div class="attrvalue">'+urndesc+'</div>';
		divhtml+='    </div>';
		var urncontact=urnelem.getElementsByTagName("contactPerson");
		if (urncontact.length>0) {
			var contact=urncontact[0];
			var temp=contact.getElementsByTagName("cn");
			var cn=temp[0].getAttribute("value");
			temp=contact.getElementsByTagName("postalAddress");
			var postal=temp[0].getAttribute("value");
			temp=contact.getElementsByTagName("phone");
			var phone=temp[0].getAttribute("value");
			temp=contact.getElementsByTagName("mail");
			var email=temp[0].getAttribute("value");
			divhtml+='    <div class="attr">';
			divhtml+='      <div class="attrname">Contact person</div>';
			divhtml+='      <div class="attrvalue">'+cn+'</div>';
			divhtml+='    </div>';
			divhtml+='    <div class="attr">';
			divhtml+='      <div class="attrname">&nbsp;</div>';
			email=email.replace(/\@/g,"_ AT _");
			divhtml+='      <div class="attrvalue">'+email+'</div>';
			divhtml+='    </div>';
			postal=postal.replace(/\$/g,"<font color='#00367D'>&gt;</font>");
			divhtml+='    <div class="attr">';
			divhtml+='      <div class="attrname">&nbsp;</div>';
			divhtml+='      <div class="attrvalue">'+postal+'</div>';
			divhtml+='    </div>';
			divhtml+='    <div class="attr">';
			divhtml+='      <div class="attrname">&nbsp;</div>';
			divhtml+='      <div class="attrvalue">'+phone+'</div>';
			divhtml+='    </div>';
		}
		divhtml+='  </div>';
		
		return divhtml;
	}
	
	URNregManager.prototype.getBlockDelegatedURNdiv = function(urnelem,showicons) {
       	var urnname=urnelem.getAttribute("value");
		var divhtml='';
		divhtml+='  <div>';
		var temp=urnelem.getElementsByTagName("httpsuri");
		var webapp=temp[0].getAttribute("value");
		divhtml+='    <div class="attr">';
		divhtml+='      <div class="attrname">Register web application</div>';
		divhtml+='      <div class="attrvalue">'+webapp+'</div>';
		divhtml+='    </div>';
		temp=urnelem.getElementsByTagName("policyuri");
		var policy=temp[0].getAttribute("value");
		divhtml+='    <div class="attr">';
		divhtml+='      <div class="attrname">Policy document</div>';
		divhtml+='      <div class="attrvalue">'+policy+'</div>';
		divhtml+='    </div>';
		temp=urnelem.getElementsByTagName("wsuri");
		var ws=temp[0].getAttribute("value");
		divhtml+='    <div class="attr">';
		divhtml+='      <div class="attrname">Web services for accesing it</div>';
		divhtml+='      <div class="attrvalue">'+ws+'</div>';
		divhtml+='    </div>';
		temp=urnelem.getElementsByTagName("ldapuri");
		if (temp.lenght>0) {
			var ldap=temp[0].getAttribute("value");
			divhtml+='    <div class="attr">';
			divhtml+='      <div class="attrname">LDAP URI for accesing it</div>';
			divhtml+='      <div class="attrvalue">'+ldap+'</div>';
			divhtml+='    </div>';
		}
		var urncontact=urnelem.getElementsByTagName("contactPerson");
		if (urncontact.length>0) {
			var contact=urncontact[0];
			temp=contact.getElementsByTagName("cn");
			var cn=temp[0].getAttribute("value");
			temp=contact.getElementsByTagName("postalAddress");
			var postal=temp[0].getAttribute("value");
			temp=contact.getElementsByTagName("phone");
			var phone=temp[0].getAttribute("value");
			temp=contact.getElementsByTagName("mail");
			var email=temp[0].getAttribute("value");
			var domain=urnelem.getAttribute("owner");
			divhtml+='    <div class="attr">';
			divhtml+='      <div class="attrname">Internet domain</div>';
			divhtml+='      <div class="attrvalue">'+domain+'</div>';
			divhtml+='    </div>';
			divhtml+='    <div class="attr">';
			divhtml+='      <div class="attrname">Contact person</div>';
			divhtml+='      <div class="attrvalue">'+cn+'</div>';
			divhtml+='    </div>';
			divhtml+='    <div class="attr">';
			divhtml+='      <div class="attrname">&nbsp;</div>';
			email=email.replace(/\@/g,"_ AT _");
			divhtml+='      <div class="attrvalue">'+email+'</div>';
			divhtml+='    </div>';
			postal=postal.replace(/\$/g,"<font color='#00367D'>&gt;</font>");
			divhtml+='    <div class="attr">';
			divhtml+='      <div class="attrname">&nbsp;</div>';
			divhtml+='      <div class="attrvalue">'+postal+'</div>';
			divhtml+='    </div>';
			divhtml+='    <div class="attr">';
			divhtml+='      <div class="attrname">&nbsp;</div>';
			divhtml+='      <div class="attrvalue">'+phone+'</div>';
			divhtml+='    </div>';
		}
		divhtml+='  </div>';
		
		return divhtml;
	}
	
	URNregManager.prototype.getURNdiv = function(urnelem) {
       	var urnname=urnelem.getAttribute("value");
       	var descs=urnelem.getElementsByTagName("description");
       	var urndesc='';
       	for (var i=0; i<descs.length; i++) {
       		urndesc=descs[i].getAttribute("value");
       	}
		var className=urnregManager.getClassName(urnname);
		var divhtml='';
		divhtml+='<div id="'+urnname+'" class="urnbox '+className+'">';
		divhtml+=urnregManager.getBlockURNdiv(urnelem,true);
		divhtml+='</div>';
		
		return divhtml;
	}
	
	URNregManager.prototype.getSubURNsDiv = function(xmldata,urnvalue) {
       	var urnarray=xmldata.getElementsByTagName("urn");
       	if (urnarray.length==0) {
       		return "";
       	}
       	var className=urnregManager.getClassName(urnvalue);
		var divhtml='';
		divhtml+='<div id="'+urnvalue+'-showsuburn" class="urnbox '+className+'">';
		divhtml+='  <div>';
		divhtml+='    <div class="titlebox">Delegated '+urnvalue+' Namespaces</div>';
       	for (var i=0; i<urnarray.length; i++) {
           	var urnelem=urnarray[i];
           	var urnname=urnelem.getAttribute("value");
            	
			divhtml+='    <div class="attrchild">';
			if (typeof(urnelem.getAttribute("type"))!="undefined"&&urnelem.getAttribute("type")=="delegated") {
				var wsuri = urnelem.getElementsByTagName("wsuri");
				divhtml+='  <div class="suburn"><span class="iconDelegated">&nbsp;</span><span class="link" onclick="urnregManager.addDelegatedURNdiv(\''+urnvalue+'-showsuburn\',\''+urnname+'\',\''+wsuri[0].getAttribute("value")+'\');">'+urnname+'</span></div>';
				divhtml+='		<div class="suburndesc" id="preview-desc-'+urnname+'">... Loading ...</div>';
				urnregManager.getDescriptionDelegatedURN(urnname,'preview-desc-'+urnname);
			}
			else if (typeof(urnelem.getAttribute("delegated"))!="undefined"&&urnelem.getAttribute("delegated")!=null) {
				divhtml+='  <div class="suburn"><span class="iconDelegated">&nbsp;</span><span class="link" onclick="urnregManager.addDelegatedURNdiv(\''+urnvalue+'-showsuburn\',\''+urnname+'\',\''+urnelem.getAttribute("delegated")+'\');">'+urnname+'</span></div>';
				divhtml+='		<div class="suburndesc" id="preview-desc-'+urnname+'">... Loading ...</div>';
				urnregManager.getDescriptionDelegatedURN(urnname,'preview-desc-'+urnname);
			}
			else {
	           	var descs=urnelem.getElementsByTagName("description");
    	       	var urndesc='';
        	   	for (var j=0; j<descs.length; j++) {
           			urndesc=descs[j].getAttribute("value");
	           	}
				divhtml+='  <div class="suburn"><span class="link" onclick="urnregManager.addURNdiv(\''+urnvalue+'-showsuburn\',\''+urnname+'\');">'+urnname+'</span></div>';
				divhtml+='		<div class="suburndesc">'+urndesc+'</div>';
			}
			divhtml+='    </div>';
       	}
           	
		divhtml+='  </div>';
		divhtml+='</div>';
				
		return divhtml;
	}
	
	URNregManager.prototype.getURNxml = function(xmldata,urnvalue) {
       	var urnarray=xmldata.getElementsByTagName("urn");
       	for (var i=0; i<urnarray.length; i++) {
       		if (urnarray[i].getAttribute("value")==urnvalue) {
       			return urnarray[i];
       		}
       	}
       	return "";
	}

	URNregManager.prototype.getDescriptionDelegatedURN = function(urnvalue,iddesc) {
		new Ajax.Request(urnregConfig.baseURL+"search/", {
			method: 'get',
			parameters: { format: "machine", urn: encodeURIComponent(urnvalue) },
			onSuccess: function(response) {
            	var xmldata=response.responseXML;
            	var urnelem = urnregManager.getURNxml(xmldata,urnvalue);
            	if (urnelem != "") {
	           		var descs=urnelem.getElementsByTagName("description");
    	    	   	var urndesc='';
        		   	for (var j=0; j<descs.length; j++) {
    	       			urndesc=descs[j].getAttribute("value");
		           	}
            		$(iddesc).innerHTML = urndesc;
            	}
            	else {
            		$(iddesc).innerHTML = "URN not found";
            	}
            }
        });
	}

	URNregManager.prototype.showURNdiv = function(urnvalue) {
		new Ajax.Request(urnregConfig.baseURL+"search/", {
			method: 'get',
			parameters: { format: "machine", urn: encodeURIComponent(urnvalue) },
			onSuccess: function(response) {
            	var xmldata=response.responseXML;
            	var urnelem = urnregManager.getURNxml(xmldata,urnvalue);
            	if (urnelem != "") {
			       	var urnname=urnelem.getAttribute("value");
					var rootElem=$("contenturns");
					rootElem.innerHTML+=urnregManager.getURNdiv(urnelem);
					Nifty("div#"+urnname,"normal");
					urnregManager.showsubURNsdiv(urnname);
            	}
            }
        });
	}

	URNregManager.prototype.showDelegatedURNdiv = function(urnvalue,wsendpoint) {
		new Ajax.Request(urnregConfig.baseWS+"urn/urn.php", {
			method: 'get',
			parameters: { oper: "geturn", urnvalue: encodeURIComponent(urnvalue), delegated: encodeURIComponent(wsendpoint) },
			onSuccess: function(response) {
            	var xmldata=response.responseXML;
            	var urnarray=xmldata.getElementsByTagName("urn");
            	if (urnarray.length>0) {
	            	var urnelem=urnarray[0];
			       	var urnname=urnelem.getAttribute("value");
					var rootElem=$("contenturns");
					rootElem.innerHTML+=urnregManager.getURNdiv(urnelem);
					Nifty("div#"+urnname,"normal");
					urnregManager.showDelegatedSubURNsdiv(urnname,wsendpoint);
				}
            }
        });
	}

	/* URNregManager.prototype.showDelegatedURNdiv = function(urnvalue,wsendpoint) {
		new Ajax.Request(urnregConfig.baseWS+"urn/urn.php", {
			method: 'get',
			parameters: { oper: "geturn", urnvalue: encodeURIComponent(urnvalue), delegated: encodeURIComponent(wsendpoint) },
			onSuccess: function(response) {
            	var xmldata=response.responseXML;
            	var urnarray=xmldata.getElementsByTagName("urn");
            	if (urnarray.length>0) {
	            	var urnelem=urnarray[0];
			       	var urnname=urnelem.getAttribute("value");
					var rootElem=$("contenturns");
					rootElem.innerHTML+=urnregManager.getURNdiv(urnelem);
					Nifty("div#"+urnname,"normal");
					urnregManager.showDelegatedSubURNsdiv(urnname,wsendpoint);
				}
            }
        });
	} */

	URNregManager.prototype.showsubURNsdiv = function(urnvalue, delegated, urnlist) {
		var mode = "description";
		if (typeof(delegated) != "undefined" && delegated==true) {
			mode = "delegated";
		}
		new Ajax.Request(urnregConfig.baseURL+"list/", {
			method: 'get',
			parameters: { format: "machine", type: mode },
			onSuccess: function(respose) {
            	var xmldata=respose.responseXML;
            	var urntokens = urnvalue.split(":");
            	var urnarray = xmldata.getElementsByTagName("urn");
            	for (var i=0; i<urnarray.length; i++) {
			       	var urnname=urnarray[i].getAttribute("value");
			       	var splittedurn = urnname.split(":");
			       	if (splittedurn.length!=(urntokens.length+1)) {
			       		var parentelem = urnarray[i].parentNode;
			       		parentelem.removeChild(urnarray[i]);
			       		i--;
			       	}
			       	else {
			       		var equals = true;
			       		for (var j=0; j<urntokens.length; j++) {
			       			equals &= urntokens[j]==splittedurn[j];
			       		}
			       		if (!equals) {
				       		var parent = urnarray[i].parentNode;
				       		parent.removeChild(urnarray[i]);
				       		i--;
			       		}
			       	}
            	}
				if (mode=="description") {
					urnregManager.showsubURNsdiv(urnvalue, true, xmldata.getElementsByTagName("urn"));
				}
				else {
					var rootElem=$("contenturns");
					for (var i=(urnlist.length-1); i>=0; i--) {
						xmldata.firstChild.insertBefore(urnlist[i],xmldata.firstChild.firstChild);
					}
					
					rootElem.innerHTML+=urnregManager.getSubURNsDiv(xmldata,urnvalue);
					Nifty("div#"+urnvalue+'-showsuburn',"normal");
				}
            }
        });
	}
	
	URNregManager.prototype.showDelegatedSubURNsdiv = function(urnvalue,wsendpoint) {
		new Ajax.Request(urnregConfig.baseWS+"urn/urn.php", {
			method: 'get',
			parameters: { oper: "getsuburns", urnvalue: encodeURIComponent(urnvalue), delegated: encodeURIComponent(wsendpoint) },
			onSuccess: function(respose) {
            	var xmldata=respose.responseXML;
				var rootElem=$("contenturns");
				rootElem.innerHTML+=urnregManager.getSubURNsDiv(xmldata,urnvalue);
				Nifty("div#"+urnvalue+'-showsuburn',"normal");
            }
        });
	}
	
	URNregManager.prototype.addURNdiv = function(suburnsdiv,urnvalue) {
		var subdiv=document.getElementById(suburnsdiv);
		var parentsubdiv=subdiv.parentNode;
		parentsubdiv.removeChild(subdiv);
		urnregManager.showURNdiv(urnvalue);
	}
	
	URNregManager.prototype.addDelegatedURNdiv = function(suburnsdiv,urnvalue,wsendpoint) {
		var subdiv=document.getElementById(suburnsdiv);
		var parentsubdiv=subdiv.parentNode;
		parentsubdiv.removeChild(subdiv);
		urnregManager.showDelegatedURNdiv(urnvalue,wsendpoint);
	}

	URNregManager.prototype.removeSubURNs = function(urnvalue) {
		var rootElem=$("contenturns");
		for (var i=0; i<rootElem.childNodes.length; i++) {
			var childElem=rootElem.childNodes[i];
			if (childElem.id==urnvalue) {
				for (var j=i+1; j<(rootElem.childNodes.length); j++) {
					var del=rootElem.childNodes[j];
					rootElem.removeChild(del);
					j--;
				}
				i=rootElem.childNodes.length;
			}
		}
	}
	
	URNregManager.prototype.setURN = function(urnvalue) {
		urnregManager.removeSubURNs(urnvalue);
		urnregManager.showsubURNsdiv(urnvalue);
	}
	
	URNregManager.prototype.setDelegatedURN = function(urnvalue,wsendpoint) {
		urnregManager.removeSubURNs(urnvalue);
		urnregManager.showDelegatedSubURNsdiv(urnvalue,wsendpoint);
	}
	
	URNregManager.prototype.search = function() {
		var search=$('search');
		new Ajax.Request(urnregConfig.baseWS+"urn/urn.php", {
			method: 'get',
			parameters: { oper: "search", search: encodeURIComponent(search.value) },
			onSuccess: function(respose) {
            	var xmldata=respose.responseXML;
				var rootElem=$("contenturns");
				rootElem.innerHTML="&nbsp;"+urnregManager.getSearchDiv(xmldata,search.value);
				Nifty("div#searchresults","normal");
            }
        });
	}

	URNregManager.prototype.getSearchDiv = function(xmldata,value) {
       	var urnarray=xmldata.getElementsByTagName("urn");
       	if (urnarray.length==0) {
       		return "";
       	}
       	var className=urnregManager.getClassName("");
		var divhtml='';
		divhtml+='<div id="searchresults" class="urnbox '+className+'">';
		divhtml+='  <div>';
		divhtml+='    <div class="titlebox">Searching '+value+'</div>';
       	for (var i=0; i<urnarray.length; i++) {
           	var urnelem=urnarray[i];
           	var urnname=urnelem.getAttribute("value");
           	var descs=urnelem.getElementsByTagName("description");
           	var urndesc='';
           	for (var j=0; j<descs.length; j++) {
           		urndesc=descs[j].getAttribute("value");
           	}
			divhtml+='    <div class="attrchild">';
			if (!urnelem.getAttribute("delegated")) {
				divhtml+='  <div class="suburn"><span class="link" onclick="urnregManager.showSearchURN(\''+urnname+'\');">'+urnname+'</span></div>';
			}
			else {
				divhtml+='  <div class="suburn"><span class="iconDelegated">&nbsp;</span><span class="link" onclick="urnregManager.showSearchDelegatedURN(\''+urnname+'\',\''+urnelem.getAttribute("delegated")+'\');">'+urnname+'</span></div>';
			}
			divhtml+='		<div class="suburndesc">'+urndesc+'</div>';
			divhtml+='    </div>';
       	}
           	
		divhtml+='  </div>';
		divhtml+='</div>';
				
		return divhtml;
	}
	
	URNregManager.prototype.showSearchURN = function(urnvalue) {
		urnregManager.removeSubURNs("searchresults");
		urnregManager.showURNdiv(urnvalue);
		
	}
	
	URNregManager.prototype.showSearchDelegatedURN = function(urnvalue,delegated) {
		urnregManager.removeSubURNs("searchresults");
		urnregManager.showDelegatedURNdiv(urnvalue,delegated);
		
	}
	
	URNregManager.prototype.setClassName = function(elem,oldname,newname) {
		if (elem.className==oldname) {
			elem.className=newname;
		}
	}
	
	URNregManager.prototype.setPressedURN = function(container,elem,newname,defaultname) {
		var root=$(container);
		var elems=root.getElementsByTagName("div");
		for (var i=0; i<elems.length; i++) {
			if (elems[i].className==newname) {
				elems[i].className=defaultname;
			}
		}
		elem.className=newname;
	}
	
	URNregManager.prototype.addNewRep = function(input,output,root,flagelem) {
		var inputElem=$(input);
		var flagElem=$(flagelem);
		var sel=flagElem.selectedIndex;
		var flag=flagElem.options[sel].value;
		flagElem.options[sel]=null;
		var repr=inputElem.value;
		var outputElem=$(output);
		if (outputElem.innerHTML=="&nbsp;") {
			outputElem.innerHTML="<div repr='"+repr+"' class='urnrow' onClick='urnregManager.setPressedURN(\"newurns\",this,\"urnrowsel\",\"urnrow\");' onMouseOver='urnregManager.setClassName(this,\"urnrow\",\"urnrowover\");' onMouseOut='urnregManager.setClassName(this,\"urnrowover\",\"urnrow\");'><img src=\"icons/flags/"+flag+".png\" alt=\"flag\" />&nbsp;"+repr+"</div>";
		}
		else {
			outputElem.innerHTML+="<div repr='"+repr+"' class='urnrow' onClick='urnregManager.setPressedURN(\"newurns\",this,\"urnrowsel\",\"urnrow\");' onMouseOver='urnregManager.setClassName(this,\"urnrow\",\"urnrowover\");' onMouseOut='urnregManager.setClassName(this,\"urnrowover\",\"urnrow\");'><img src=\"icons/flags/"+flag+".png\" alt=\"flag\" />&nbsp;"+repr+"</div>";
		}
		inputElem.value=root;
	}
	
	URNregManager.prototype.delNewRep = function (container,newname,flags) {
		var root=$(container);
		var elems=root.getElementsByTagName("div");
		for (var i=0; i<elems.length; i++) {
			if (elems[i].className==newname) {
				var img=elems[i].getElementsByTagName("img");
				var flagname=img[0].src.substr(img[0].src.lastIndexOf("/")+1,2);
				var added=false;
				for (var j=0; j<$(flags).options.length; j++) {
					if ($(flags).options[j].value>flagname) {
						for (var k=($(flags).options.length-1); k>=j; k--) {
							$(flags).options[k+1]=new Option($(flags).options[k].value,$(flags).options[k].value);
						}
						$(flags).options[j]=new Option(flagname,flagname);
						added=true;
						j=$(flags).options.length;
					}
				}
				if (added==false) {
					$(flags).options[$(flags).options.length]=new Option(flagname,flagname);
				}
				var parent=elems[i].parentNode;
				parent.removeChild(elems[i]);
				i=elems.length;
			}
		}
	}

	URNregManager.prototype.getAddForm = function (urnvalue) {
       	var className=urnregManager.getClassName(urnvalue);
		var divhtml='<form id="addurnform" name="addurnform">';
		divhtml+='<div id="addnewurn" class="urnbox '+className+'">';
		divhtml+='  <div id="fillhtml">';
		divhtml+='    <div class="titlebox">Registering new child URN of '+urnvalue+'</div>';
		divhtml+='    <div class="subtitlebox" id="error_msg" style="display: none; color: red;">&nbsp;</div>';
		divhtml+='    <div id="choosing">';
		divhtml+='      <div class="attr">';
		divhtml+='  	  <div class="attrname">Choose action</div>';
		divhtml+='  		<div class="attrvalue"><select onChange="urnregManager.putAddRegForm(\''+urnvalue+'\');" id="mode" name="mode" class="inputselect"><option value="del">Request a delegation</option><option value="reg">Register an URN</option></select></div>';
		divhtml+='      </div>';
		divhtml+='    </div>';
		divhtml+='    <div id="contentform">&nbsp;</div>';
		divhtml+='  </div>';
		divhtml+='</div>';
		divhtml+='</form>';
		
		return divhtml;
	}
	
	URNregManager.prototype.putAddRegForm = function (urnvalue) {
		var container=$("contentform");
		var option=$("mode");
		var mode=option.options[option.selectedIndex].value;
		if (mode=="del") {
			container.innerHTML=urnregManager.getAddDelForm(urnvalue);
		}
		else {
			container.innerHTML=urnregManager.getAddRegForm(urnvalue);
		}
	}
	
	URNregManager.prototype.getAddRegForm = function (urnvalue) {
		var date=new Date();
		var divhtml='    <div class="subtitlebox">URN information</div>';
		divhtml+='	  <div class="infobox">You need to set which URN you want to register and also a short description about itself. Optionally, you can set their presentations (human readable information) in different languages, so you should choose the ISO code of the language and its value.</div>';
		divhtml+='    <div class="attr">';
		divhtml+='  	<div class="attrname">URN value</div>';
		divhtml+='		<div class="attrvalue"><input type="text" value="'+urnvalue+':" name="urnvalue" id="urnvalue" class="inputtext" /></div>';
		divhtml+='    </div>';
		divhtml+='    <div class="attr">';
		divhtml+='  	<div class="attrname">Description</div>';
		divhtml+='		<div class="attrvalue"><textarea name="desc" class="inputtext" ></textarea></div>';
		divhtml+='    </div>';
		divhtml+='    <div class="attr">';
		divhtml+='  	<div class="attrname">Presentations</div>';
		divhtml+='		<div class="attrvalue">';
		divhtml+='		  <table border="0" style="width: 90%;">';
		divhtml+='	 	    <tbody>';
		divhtml+='	 	      <tr>';
		divhtml+='	 	        <td>ISO:&nbsp;<select id="coun" name="coun" class="inputselect">';
		divhtml+='<option value="ad">ad</option><option value="ae">ae</option><option value="af">af</option><option value="ag">ag</option><option value="ai">ai</option><option value="al">al</option><option value="am">am</option><option value="an">an</option><option value="ao">ao</option><option value="ar">ar</option><option value="as">as</option><option value="at">at</option><option value="au">au</option><option value="aw">aw</option><option value="ax">ax</option><option value="az">az</option><option value="ba">ba</option><option value="bb">bb</option><option value="bd">bd</option><option value="be">be</option><option value="bf">bf</option><option value="bg">bg</option><option value="bh">bh</option><option value="bi">bi</option><option value="bj">bj</option><option value="bm">bm</option><option value="bn">bn</option><option value="bo">bo</option><option value="br">br</option><option value="bs">bs</option><option value="bt">bt</option><option value="bv">bv</option><option value="bw">bw</option><option value="by">by</option><option value="bz">bz</option><option value="ca">ca</option><option value="cc">cc</option><option value="cd">cd</option><option value="cf">cf</option><option value="cg">cg</option><option value="ch">ch</option><option value="ci">ci</option><option value="ck">ck</option><option value="cl">cl</option><option value="cm">cm</option><option value="cn">cn</option><option value="co">co</option><option value="cr">cr</option><option value="cs">cs</option><option value="cu">cu</option><option value="cv">cv</option><option value="cx">cx</option><option value="cy">cy</option><option value="cz">cz</option><option value="de">de</option><option value="dj">dj</option><option value="dk">dk</option><option value="dm">dm</option><option value="do">do</option><option value="dz">dz</option><option value="ec">ec</option><option value="ee">ee</option><option value="eg">eg</option><option value="eh">eh</option><option value="en" selected="true">en</option><option value="er">er</option><option value="es">es</option><option value="et">et</option><option value="fam">fam</option><option value="fi">fi</option><option value="fj">fj</option><option value="fk">fk</option><option value="fm">fm</option><option value="fo">fo</option><option value="fr">fr</option><option value="ga">ga</option><option value="gb">gb</option><option value="gd">gd</option><option value="ge">ge</option><option value="gf">gf</option><option value="gh">gh</option><option value="gi">gi</option><option value="gl">gl</option><option value="gm">gm</option><option value="gn">gn</option><option value="gp">gp</option><option value="gq">gq</option><option value="gr">gr</option><option value="gs">gs</option><option value="gt">gt</option><option value="gu">gu</option><option value="gw">gw</option><option value="gy">gy</option><option value="hk">hk</option><option value="hm">hm</option><option value="hn">hn</option><option value="hr">hr</option><option value="ht">ht</option><option value="hu">hu</option><option value="id">id</option><option value="ie">ie</option><option value="il">il</option><option value="in">in</option><option value="io">io</option><option value="iq">iq</option><option value="ir">ir</option><option value="is">is</option><option value="it">it</option><option value="jm">jm</option><option value="jo">jo</option><option value="jp">jp</option><option value="ke">ke</option><option value="kg">kg</option><option value="kh">kh</option><option value="ki">ki</option><option value="km">km</option><option value="kn">kn</option><option value="kp">kp</option><option value="kr">kr</option><option value="kw">kw</option><option value="ky">ky</option><option value="kz">kz</option><option value="la">la</option><option value="lb">lb</option><option value="lc">lc</option><option value="li">li</option><option value="list">list</option><option value="lk">lk</option><option value="lr">lr</option><option value="ls">ls</option><option value="lt">lt</option><option value="lu">lu</option><option value="lv">lv</option><option value="ly">ly</option><option value="ma">ma</option><option value="mc">mc</option><option value="md">md</option><option value="me">me</option><option value="mg">mg</option><option value="mh">mh</option><option value="mk">mk</option><option value="ml">ml</option><option value="mm">mm</option><option value="mn">mn</option><option value="mo">mo</option><option value="mp">mp</option><option value="mq">mq</option><option value="mr">mr</option><option value="ms">ms</option><option value="mt">mt</option><option value="mu">mu</option><option value="mv">mv</option>';
		divhtml+='<option value="mw">mw</option><option value="mx">mx</option><option value="my">my</option><option value="mz">mz</option><option value="na">na</option><option value="nc">nc</option><option value="ne">ne</option><option value="nf">nf</option><option value="ng">ng</option><option value="ni">ni</option><option value="nl">nl</option><option value="no">no</option><option value="np">np</option><option value="nr">nr</option><option value="nu">nu</option><option value="nz">nz</option><option value="om">om</option><option value="pa">pa</option><option value="pe">pe</option><option value="pf">pf</option><option value="pg">pg</option><option value="ph">ph</option><option value="pk">pk</option><option value="pl">pl</option><option value="pm">pm</option><option value="pn">pn</option><option value="pr">pr</option><option value="ps">ps</option><option value="pt">pt</option><option value="pw">pw</option><option value="py">py</option><option value="qa">qa</option><option value="re">re</option><option value="ro">ro</option><option value="rs">rs</option><option value="ru">ru</option><option value="rw">rw</option><option value="sa">sa</option><option value="sb">sb</option><option value="sc">sc</option><option value="sd">sd</option><option value="se">se</option><option value="sg">sg</option><option value="sh">sh</option><option value="si">si</option><option value="sj">sj</option><option value="sk">sk</option><option value="sl">sl</option><option value="sm">sm</option><option value="sn">sn</option><option value="so">so</option><option value="sr">sr</option><option value="st">st</option><option value="sv">sv</option><option value="sy">sy</option><option value="sz">sz</option><option value="tc">tc</option><option value="td">td</option><option value="tf">tf</option><option value="tg">tg</option><option value="th">th</option><option value="tj">tj</option><option value="tk">tk</option><option value="tl">tl</option><option value="tm">tm</option><option value="tn">tn</option><option value="to">to</option><option value="tr">tr</option><option value="tt">tt</option><option value="tv">tv</option><option value="tw">tw</option><option value="tz">tz</option><option value="ua">ua</option><option value="ug">ug</option><option value="um">um</option><option value="us">us</option><option value="uy">uy</option><option value="uz">uz</option><option value="va">va</option><option value="vc">vc</option><option value="ve">ve</option><option value="vg">vg</option><option value="vi">vi</option><option value="vn">vn</option><option value="vu">vu</option><option value="wf">wf</option><option value="ws">ws</option><option value="ye">ye</option><option value="yt">yt</option><option value="za">za</option><option value="zm">zm</option><option value="zw">zw</option>';
		divhtml+=' 			    </select></td>';
		divhtml+='	 	        <td style="vertical-align: middle;"><input type="text" value="" name="presentation" id="presentation" class="inputtext" style="width: 100%;"/></td>';
		divhtml+='	 	        <td style="vertical-align: middle; padding-left: 8px;"><span title="Add this presentation for that language" onclick="urnregManager.addNewRep(\'presentation\',\'newurns\',\'\',\'coun\');"><img src="icons/arrow-down.gif" class="icon" alt="x" /></span></td>';
		divhtml+='	 	      </tr>';
		divhtml+='	 	      <tr>';
		divhtml+='	 	        <td colspan="2"><div id="newurns" style="height: 6em; border: 1px solid black; background: #ffffff; width: 100%; overflow: auto;">&nbsp;</div></td>';
		divhtml+='	 	        <td style="vertical-align: top; padding-left: 8px;"><span title="Remove the selected presentation" onclick="urnregManager.delNewRep(\'newurns\',\'urnrowsel\',\'coun\');"><img src="icons/x.gif" alt="x" class="icon"/></span></td>';
		divhtml+='	 	      </tr>';
		divhtml+='	 	    </tbody>';
		divhtml+='		  </table>';
		divhtml+='      </div>';
		divhtml+='    </div>';
		divhtml+='    <div class="subtitlebox">Registration information</div>';
		divhtml+='	  <div class="infobox">This is the date in which the URN will be registered at.</div>';
		divhtml+='    <div class="attr">';
		divhtml+='  	<div class="attrname">Reg. Date</div>';
		divhtml+='		<div class="attrvalue"><input type="text" value="'+(date.getMonth()+1)+'/'+date.getDate()+'/'+(date.getYear()+1900)+'" name="urnregdata" id="urnregurl" class="inputtext" readonly="true" /></div>';
		divhtml+='    </div>';
		divhtml+='    <div class="subtitlebox">Register contact person</div>';
		divhtml+='	  <div class="infobox">It\'s needed to fill the information about the contact person for this URN.</div>';
		divhtml+='    <div class="attr">';
		divhtml+='  	<div class="attrname">Common name</div>';
		divhtml+='		<div class="attrvalue"><input type="text" value="" name="cn" class="inputtext" /></div>';
		divhtml+='    </div>';
		divhtml+='    <div class="attr">';
		divhtml+='  	<div class="attrname">Given name</div>';
		divhtml+='		<div class="attrvalue"><input type="text" value="" name="gn" class="inputtext" /></div>';
		divhtml+='    </div>';
		divhtml+='    <div class="attr">';
		divhtml+='  	<div class="attrname">First surname</div>';
		divhtml+='		<div class="attrvalue"><input type="text" value="" name="sn1" class="inputtext" /></div>';
		divhtml+='    </div>';
		divhtml+='    <div class="attr">';
		divhtml+='  	<div class="attrname">Second surname</div>';
		divhtml+='		<div class="attrvalue"><input type="text" value="" name="sn2" class="inputtext" /></div>';
		divhtml+='    </div>';
		divhtml+='    <div class="attr">';
		divhtml+='  	<div class="attrname">Postal address</div>';
		divhtml+='		<div class="attrvalue"><textarea name="pa" class="inputtext" ></textarea></div>';
		divhtml+='    </div>';
		divhtml+='    <div class="attr">';
		divhtml+='  	<div class="attrname">Country</div>';
		divhtml+='		<div class="attrvalue"><input type="text" value="" name="co" class="inputtext" /></div>';
		divhtml+='    </div>';
		divhtml+='    <div class="attr">';
		divhtml+='  	<div class="attrname">Phone</div>';
		divhtml+='		<div class="attrvalue"><input type="text" value="" name="ph" class="inputtext" /></div>';
		divhtml+='    </div>';
		divhtml+='    <div class="attr">';
		divhtml+='  	<div class="attrname">Email</div>';
		divhtml+='		<div class="attrvalue"><input type="text" value="" name="em" class="inputtext" /></div>';
		divhtml+='    </div>';
		divhtml+='    <div class="buttonrow">';
		divhtml+='  	<table style="width: 100%";><tbody><tr><td style="width: 50%; text-align: center;"><div id="button1" class="button"><a href="#" onclick="urnregManager.setURN(\''+urnvalue+'\');">Cancel</a></div></td><td style="width: 50%; text-align: center;"><div id="button2" class="button"><a href="#" onclick="urnregManager.submitAddForm(\'addurnform\');">Accept</a></div></td></tr></tbody></table>';
		divhtml+='    </div>';
		
		return divhtml;
	}
	
	URNregManager.prototype.getAddDelForm = function (urnvalue) {
		var date=new Date();
		var divhtml='    <div class="subtitlebox">URN information</div>';
		divhtml+='	  <div class="infobox">You need to set which URN you want to get a delegation.</div>';
		divhtml+='    <div class="attr">';
		divhtml+='  	<div class="attrname">URN value</div>';
		divhtml+='		<div class="attrvalue"><input type="text" value="'+urnvalue+':" name="urnvalue" id="urnvalue" class="inputtext" /></div>';
		divhtml+='    </div>';
		divhtml+='    <div class="subtitlebox">Registration information</div>';
		divhtml+='	  <div class="infobox">This is the date in which the URN will be registered at.</div>';
		divhtml+='    <div class="attr">';
		divhtml+='  	<div class="attrname">Reg. Date</div>';
		divhtml+='		<div class="attrvalue"><input type="text" value="'+(date.getMonth()+1)+'/'+date.getDate()+'/'+(date.getYear()+1900)+'" name="urnregdata" id="urnregurl" class="inputtext" readonly="true" /></div>';
		divhtml+='    </div>';
		divhtml+='    <div class="subtitlebox">Resources of the delegation</div>';
		divhtml+='	  <div class="infobox">When you request a delegation, you have to set the following information in order to get approved it. Remember that if you aren\'t using URNreg for providing the web services, your software (or a set of nice static XML and HTML pages) must conform the specification of the <a href="../browser/api.php">API</a>.</div>';
		divhtml+='    <div class="attr">';
		divhtml+='  	<div class="attrname">Register web application</div>';
		divhtml+='		<div class="attrvalue"><input type="text" value="https://" name="regURI" id="regURI" class="inputtext" /></div>';
		divhtml+='    </div>';
		divhtml+='    <div class="attr">';
		divhtml+='  	<div class="attrname">Policy document</div>';
		divhtml+='		<div class="attrvalue"><input type="text" value="https://" name="polURI" id="polURI" class="inputtext" /></div>';
		divhtml+='    </div>';
		divhtml+='    <div class="attr">';
		divhtml+='  	<div class="attrname">Web services for accesing it</div>';
		divhtml+='		<div class="attrvalue"><input type="text" value="https://" name="httpsURI" id="httpsURI" class="inputtext" /></div>';
		divhtml+='    </div>';
		divhtml+='    <div class="attr">';
		divhtml+='  	<div class="attrname">LDAP URI for accesing it <label style="font-style: italic; font-size: 90%;">[OPTIONAL]</label></div>';
		divhtml+='		<div class="attrvalue"><input type="text" value="ldap://" name="ldapURI" id="ldapURI" class="inputtext" /></div>';
		divhtml+='    </div>';
		divhtml+='    <div class="subtitlebox">Register contact person</div>';
		divhtml+='	  <div class="infobox">It\'s needed to fill the information about the contact person for this URN.</div>';
		divhtml+='    <div class="attr">';
		divhtml+='  	<div class="attrname">Internet domain of your org.</div>';
		divhtml+='		<div class="attrvalue"><input type="text" value="domain.org" name="owner" id="owner" class="inputtext" /></div>';
		divhtml+='    </div>';
		divhtml+='    <div class="attr">';
		divhtml+='  	<div class="attrname">Common name</div>';
		divhtml+='		<div class="attrvalue"><input type="text" value="" name="cn" class="inputtext" /></div>';
		divhtml+='    </div>';
		divhtml+='    <div class="attr">';
		divhtml+='  	<div class="attrname">Given name</div>';
		divhtml+='		<div class="attrvalue"><input type="text" value="" name="gn" class="inputtext" /></div>';
		divhtml+='    </div>';
		divhtml+='    <div class="attr">';
		divhtml+='  	<div class="attrname">First surname</div>';
		divhtml+='		<div class="attrvalue"><input type="text" value="" name="sn1" class="inputtext" /></div>';
		divhtml+='    </div>';
		divhtml+='    <div class="attr">';
		divhtml+='  	<div class="attrname">Second surname</div>';
		divhtml+='		<div class="attrvalue"><input type="text" value="" name="sn2" class="inputtext" /></div>';
		divhtml+='    </div>';
		divhtml+='    <div class="attr">';
		divhtml+='  	<div class="attrname">Postal address</div>';
		divhtml+='		<div class="attrvalue"><textarea name="pa" class="inputtext" ></textarea></div>';
		divhtml+='    </div>';
		divhtml+='    <div class="attr">';
		divhtml+='  	<div class="attrname">Country</div>';
		divhtml+='		<div class="attrvalue"><input type="text" value="" name="co" class="inputtext" /></div>';
		divhtml+='    </div>';
		divhtml+='    <div class="attr">';
		divhtml+='  	<div class="attrname">Phone</div>';
		divhtml+='		<div class="attrvalue"><input type="text" value="" name="ph" class="inputtext" /></div>';
		divhtml+='    </div>';
		divhtml+='    <div class="attr">';
		divhtml+='  	<div class="attrname">Email</div>';
		divhtml+='		<div class="attrvalue"><input type="text" value="" name="em" class="inputtext" /></div>';
		divhtml+='    </div>';
		divhtml+='    <div class="buttonrow">';
		divhtml+='  	<table style="width: 100%";><tbody><tr><td style="width: 50%; text-align: center;"><div id="button1" class="button"><a href="#" onclick="urnregManager.setURN(\''+urnvalue+'\');">Cancel</a></div></td><td style="width: 50%; text-align: center;"><div id="button2" class="button"><a href="#" onclick="urnregManager.submitAddDelegForm(\'addurnform\');">Accept</a></div></td></tr></tbody></table>';
		divhtml+='    </div>';
		
		return divhtml;
	}
	
	URNregManager.prototype.showAddForm = function (urnvalue) {
		urnregManager.removeSubURNs(urnvalue);
		var rootElem=$("contenturns");
		rootElem.innerHTML+="&nbsp;"+urnregManager.getAddForm(urnvalue);
		urnregManager.putAddRegForm(urnvalue);

		Nifty("div#addnewurn","normal");
		Nifty("div#button1 a","transparent");
		Nifty("div#button2 a","transparent");
	}
	
	URNregManager.prototype.submitAddForm = function (nameform) {
		var form=document.forms[nameform];
		var error="";
		if (form.urnvalue.value=="") {
			error="ERROR: The URN is not valid";
		}
		else if (urnregManager.trimAll(form.desc.value)=="") {
			error="ERROR: The description of the URN is not valid";
		}
		else if (urnregManager.trimAll(form.cn.value)=="") {
			error="ERROR: The common name of the contact person is not valid";
		}
		else if (urnregManager.trimAll(form.gn.value)=="") {
			error="ERROR: The given name of the contact person is not valid";
		}
		else if (urnregManager.trimAll(form.sn1.value)=="") {
			error="ERROR: The first surname of the contact person is not valid";
		}
		else if (urnregManager.trimAll(form.pa.value)=="") {
			error="ERROR: The postal address of the contact person is not valid";
		}
		else if (urnregManager.trimAll(form.co.value)=="") {
			error="ERROR: The country of the contact person is not valid";
		}
		else if (urnregManager.trimAll(form.em.value)=="") {
			error="ERROR: The email of the contact person is not valid";
		}
		
		if (error=="") {
			var resxml="<urn_registry>";
			resxml+="<urn_data value='"+form.urnvalue.value+"'>";
			resxml+="<description value='"+encode64(form.desc.value)+"'/>";
			resxml+="<presentations>";
			var root=$('newurns');
			var elems=root.getElementsByTagName("div");
			for (var i=0; i<elems.length; i++) {
				if (elems[i].className=='urnrow'||elems[i].className=='urnrowsel') {
					var img=elems[i].getElementsByTagName("img");
					var flagname=img[0].src.substr(img[0].src.lastIndexOf("/")+1,2);
					resxml+="<presentation lang='"+flagname+"' value='"+encode64(elems[i].getAttribute("repr"))+"'/>";
				}
			}
			resxml+="</presentations>";
			resxml+="<contact_person>";
			resxml+="<cn value='"+encode64(form.cn.value)+"'/>";
			resxml+="<given_name value='"+encode64(form.gn.value)+"'/>";
			resxml+="<sn1 value='"+encode64(form.sn1.value)+"'/>";
			resxml+="<sn2 value='"+encode64(form.sn2.value)+"'/>";
			resxml+="<postal_address value='"+encode64(form.pa.value)+"'/>";
			resxml+="<country value='"+encode64(form.co.value)+"'/>";
			resxml+="<phone value='"+encode64(form.ph.value)+"'/>";
			resxml+="<email value='"+encode64(form.em.value)+"'/>";
			resxml+="</contact_person>";
			resxml+="</urn_data>";
			resxml+="</urn_registry>";
			var params = "oper=addurn&urntype=urnreg&urndata="+encode64(resxml);
			var ajx = new Ajax.Updater("test",urnregConfig.baseWS+"/urn/urn.php",{method: "post",parameters: params,onComplete: urnregManager.showAddedMsg});
		}
		else {
			$('error_msg').innerHTML=error;
			$('error_msg').style.display='block';
		}
	}
	
	URNregManager.prototype.submitAddDelegForm = function (nameform) {
		var form=document.forms[nameform];
		var error="";
		if (form.urnvalue.value=="") {
			error="ERROR: The URN is not valid";
		}
		else if (urnregManager.trimAll(form.regURI.value)=="") {
			error="ERROR: The register web application is not valid";
		}
		else if (urnregManager.trimAll(form.polURI.value)=="") {
			error="ERROR: The policy document is not valid";
		}
		else if (urnregManager.trimAll(form.httpsURI.value)=="") {
			error="ERROR: The web services URL is not valid";
		}
		else if (urnregManager.trimAll(form.owner.value)=="") {
			error="ERROR: The internet domain of the contact person is not valid";
		}
		else if (urnregManager.trimAll(form.cn.value)=="") {
			error="ERROR: The common name of the contact person is not valid";
		}
		else if (urnregManager.trimAll(form.gn.value)=="") {
			error="ERROR: The given name of the contact person is not valid";
		}
		else if (urnregManager.trimAll(form.sn1.value)=="") {
			error="ERROR: The first surname of the contact person is not valid";
		}
		else if (urnregManager.trimAll(form.pa.value)=="") {
			error="ERROR: The postal address of the contact person is not valid";
		}
		else if (urnregManager.trimAll(form.co.value)=="") {
			error="ERROR: The country of the contact person is not valid";
		}
		else if (urnregManager.trimAll(form.em.value)=="") {
			error="ERROR: The email of the contact person is not valid";
		}
		
		if (error=="") {
			var resxml="<urn_registry>";
			resxml+="<urn_data value='"+form.urnvalue.value+"' type='delegated'>";
			resxml+="<access_data>";
			resxml+="<regwebapp value='"+encode64(form.regURI.value)+"'/>";
			resxml+="<policy value='"+encode64(form.polURI.value)+"'/>";
			resxml+="<webservices value='"+encode64(form.httpsURI.value)+"'/>";
			if (urnregManager.trimAll(form.ldapURI.value)!="") {
				resxml+="<ldap value='"+encode64(form.ldapURI.value)+"'/>";
			}
			resxml+="</access_data>";
			resxml+="<contact_person>";
			resxml+="<domain value='"+encode64(form.owner.value)+"'/>";
			resxml+="<cn value='"+encode64(form.cn.value)+"'/>";
			resxml+="<given_name value='"+encode64(form.gn.value)+"'/>";
			resxml+="<sn1 value='"+encode64(form.sn1.value)+"'/>";
			resxml+="<sn2 value='"+encode64(form.sn2.value)+"'/>";
			resxml+="<postal_address value='"+encode64(form.pa.value)+"'/>";
			resxml+="<country value='"+encode64(form.co.value)+"'/>";
			resxml+="<phone value='"+encode64(form.ph.value)+"'/>";
			resxml+="<email value='"+encode64(form.em.value)+"'/>";
			resxml+="</contact_person>";
			resxml+="</urn_data>";
			resxml+="</urn_registry>";
			var params = "oper=addurn&urntype=urndel&urndata="+encode64(resxml);
			var ajx = new Ajax.Updater("test",urnregConfig.baseWS+"/urn/urn.php",{method: "post",parameters: params,onComplete: urnregManager.showAddedMsg});
		}
		else {
			$('error_msg').innerHTML=error;
			$('error_msg').style.display='block';
		}
	}
	
	URNregManager.prototype.showAddedMsg = function (resp) {
		var xmlData=resp.responseXML;
		var oper=xmlData.getElementsByTagName("Status");
		if (oper[0].getAttribute("status")=='success') {
			var fillcontainer=$('fillhtml');
			var divhtml='  <div>';
			divhtml+='    <div class="titlebox">Approval pending. You will receive more news by email.</div>';
			divhtml+='  </div>';
			fillcontainer.innerHTML=divhtml;
		}
		else {
			var msg=xmlData.getElementsByTagName("ErrorMessage");
			$('error_msg').innerHTML="ERROR: "+msg[0].getAttribute("message");
			$('error_msg').style.display='block';
		}
	}
	
	URNregManager.prototype.showPendingURN = function () {
		new Ajax.Request(urnregConfig.baseWS+"urn/urn.php", {
			method: 'get',
			parameters: { oper: "getpendingurn" },
			onSuccess: function(respose) {
            	var xmldata=respose.responseXML;
				var rootElem=$("infopending");
				var data="<div id='listurns'>";
		       	var urnarray=xmldata.getElementsByTagName("urn");
		       	for (var i=0; i<urnarray.length; i++) {
		       		var value=urnarray[i].getAttribute("value");
		       		var type=urnarray[i].getAttribute("type");
	    	   		var newhtml='<div id="urnprereg-'+value+'" class="urnbox urnprereg">';
		       		if (type&&type=="delegated") {
			       		newhtml+='<div id="pending-'+value+'"><span style="float: right;">Delegated URN</span><span urn="'+value+'" class="iconDownArrow" onClick="urnregManager.showInfoPendUrn(\''+value+'\',\'pending-'+value+'\');">&nbsp;</span><span>'+value+'</span></div>';
			       		newhtml+='<div id="show-'+value+'" class="showdatapendingurn">';
			       		newhtml+=urnregManager.getBlockDelegatedURNdiv(urnarray[i],false);
		       		}
		       		else {
			       		newhtml+='<div id="pending-'+value+'"><span style="float: right;">Registered URN</span><span urn="'+value+'" class="iconDownArrow" onClick="urnregManager.showInfoPendUrn(\''+value+'\',\'pending-'+value+'\');">&nbsp;</span><span>'+value+'</span></div>';
			       		newhtml+='<div id="show-'+value+'" class="showdatapendingurn">';
			       		newhtml+=urnregManager.getBlockURNdiv(urnarray[i],false);
			       	}
					newhtml+='    <div class="buttonrow">';
					newhtml+='  	<table style="width: 100%";><tbody><tr><td style="width: 50%; text-align: center;"><div id="button1-'+value+'" class="buttonpending"><a href="#" onclick="urnregManager.cancelUrn(\''+value+'\');">Cancel</a></div></td><td style="width: 50%; text-align: center;"><div id="button2-'+value+'" class="buttonpending"><a href="#" onclick="urnregManager.acceptUrn(\''+value+'\');">Accept</a></div></td></tr></tbody></table>';
					newhtml+='    </div>';
		       		newhtml+='</div>';
		       		newhtml+='</div>';
		       		
		       		data+=newhtml;
		       	}
		       	
				data+="</div>";
				
				rootElem.innerHTML+=data;

		       	for (var i=0; i<urnarray.length; i++) {
		       		var value=urnarray[i].getAttribute("value");
		            Nifty("div#urnprereg-"+value,"normal");
					Nifty("div#button1-"+value+" a","transparent");
					Nifty("div#button2-"+value+" a","transparent");
		       	}
            }
        });
	}
	
	URNregManager.prototype.showInfoPendUrn = function (urn,container) {
		var list=$(container).getElementsByTagName("span");
		for (var i=0; i<list.length; i++) {
			if (list[i].className=='iconDownArrow') {
				list[i].className='iconUpArrow';
				var urn=list[i].getAttribute("urn");
				$("show-"+urn).style.display="block";
			}
			else if (list[i].className=='iconUpArrow') {
				list[i].className='iconDownArrow';
				var urn=list[i].getAttribute("urn");
				$("show-"+urn).style.display="none";
			}
		}
	}
	
	URNregManager.prototype.initShowPendingURN = function (resp) {
		var xmlData=resp.responseXML;
		var oper=xmlData.getElementsByTagName("Status");
		if (oper[0].getAttribute("status")=='success') {
			var toRemove=$('listurns');
			var parent=toRemove.parentNode;
			parent.removeChild(toRemove);
			var msg=$('error_admin_msg');
			// ToDo: mensaje de que todo ha ido bien
			var info=xmlData.getElementsByTagName("InfoMessage");
			msg.innerHTML="<strong>SUCCESS</strong>: "+info[0].getAttribute("message");
			msg.style.color="blue";
			msg.style.display="block";
			urnregManager.showPendingURN();
		}
		else {
			var err=xmlData.getElementsByTagName("ErrorMessage");
			var msg=$('error_admin_msg');
			msg.innerHTML="<strong>ERROR</strong>: "+err[0].getAttribute("message");
			msg.style.color="red";
			msg.style.display="block";
		}
	}
	
	URNregManager.prototype.cancelUrn = function (urn) {
		var params = "oper=addurn&action=cancel&urn="+urn;
		var ajx = new Ajax.Updater("test",urnregConfig.baseWS+"/urn/urnsave.php",{method: "post",parameters: params, onComplete: urnregManager.initShowPendingURN});
	}

	
	URNregManager.prototype.acceptUrn = function (urn) {
		var params = "oper=addurn&action=accept&urn="+urn;
		var ajx = new Ajax.Updater("test",urnregConfig.baseWS+"/urn/urnsave.php",{method: "post",parameters: params, onComplete: urnregManager.initShowPendingURN});
	}

}