<?php
if (!isset($siledap_path)) {
	require_once("../../../config.php");
}
require_once($urnreg_path."/common.php");
require_once($urnreg_path."/urn_auth.php");
require_once($siledap_path."/LdapConf.php");
require_once($siledap_path."/LdapManager.php");

$URN_PENDING='urn:mace:terena.org:schac:userStatus:edugain:registry:pending';

$error='';

function cancelUrn($lm,$urn) {
	GLOBAL $EMAIL_SENDER;
	GLOBAL $EMAIL_BCC;
	GLOBAL $EMAIL_SUBJECT;
	GLOBAL $EMAIL_REJECT_TEXT;
	GLOBAL $error;
	
	$entry=getURNEntry($lm,$urn);
	if (is_string($entry)) {
		$error="URN not found";
		return false;
	}
	
	$to = $entry->getSingleAttribute("mail");
	
	if ($lm->delEntry($entry->getDN(),false)) {
		$subject = str_replace("%%URN_VALUE%%",$urn,$EMAIL_SUBJECT);
		$text = $EMAIL_REJECT_TEXT;
		$headers = 'From: ' . $EMAIL_SENDER . "\r\n" .
    	'Bcc: ' . $EMAIL_BCC . "\r\n" .
    	'Reply-To: ' . $EMAIL_SENDER . "\r\n" .
    	'X-Mailer: PHP/' . phpversion();
		mail($to,$subject,$text,$headers);
		$error="URN ".$urn." has been rejected";
		return true;
	}
	else {
		return false;
	}
}

function acceptUrn($lm,$urn) {
	GLOBAL $EMAIL_SENDER;
	GLOBAL $EMAIL_BCC;
	GLOBAL $EMAIL_SUBJECT;
	GLOBAL $EMAIL_ACCEPT_TEXT;
	GLOBAL $error;
	
	$entry=getURNEntry($lm,$urn);
	if (is_string($entry)) {
		$error="URN not found";
		return false;
	}
	
	$to = $entry->getSingleAttribute("mail");
	
	$attrs=array();
	$attrs['schacUserStatus']=array();
	
	if (ldap_modify($lm->getLdapLink(),$entry->getDN(),$attrs)) {
		$subject = str_replace("%%URN_VALUE%%",$urn,$EMAIL_SUBJECT);
		$text = $EMAIL_ACCEPT_TEXT;
		$headers = 'From: ' . $EMAIL_SENDER . "\r\n" .
    	'Bcc: ' . $EMAIL_BCC . "\r\n" .
    	'Reply-To: ' . $EMAIL_SENDER . "\r\n" .
    	'X-Mailer: PHP/' . phpversion();
		mail($to,$subject,$text,$headers);
		$error="URN ".$urn." has been accepted";
		return true;
	}
	else {
		return false;
	}
}

session_start();

header('Content-type: text/xml');
echo "<Response>";

if (auth_user()) {
	$lm=new LdapManager($LDAP_SERVER_NAME,$LDAP_SERVER_PORT);
	$lm->setOption(LDAP_OPT_PROTOCOL_VERSION,3);
	$lm->connectLdap($LDAP_USER,$LDAP_PASS);
		
	$success=false;
		
	if (array_key_exists('oper',$_REQUEST)) {
		$oper=$_REQUEST['oper'];
		if (strcmp($oper,"addurn")==0) { // Get an urn
			if (array_key_exists('action',$_REQUEST)&&array_key_exists('urn',$_REQUEST)) {
				$action=rawurldecode($_REQUEST['action']);
				$urn=rawurldecode($_REQUEST['urn']);
				if (strcmp($action,"cancel")==0) {
					$success=cancelUrn($lm,$urn);
				}
				else if (strcmp($action,"accept")==0) {
					$success=acceptUrn($lm,$urn);
				}
			}
		}
	}
}
else {
	$success=false;
	$error="You're not an admin";
}
if ($success==true) {
    echo "<OperationInfo><Status status='success'/>";
    if (strcmp($error,"")!=0) {
    	echo "<InfoMessage message='".$error."'/>";
    }
    echo "</OperationInfo>";
}
else {
    echo "<OperationInfo><Status status='fail'/><ErrorMessage message='".$error."'/></OperationInfo>";
}
echo "</Response>";

?>
